<script>
import Layout from "../../Layouts/Layout.vue";
import {Head, useForm} from "@inertiajs/vue3";
import CourseContent from "../../Components/CourseContent.vue"
import CodeArea from "../../Components/CodeArea.vue";
import {ref, watch} from "vue";
import PrimaryButton from "../../Components/PrimaryButton.vue";

export default {
  components: {
    PrimaryButton,
    CodeArea, Head, CourseContent
  },

  layout: Layout,

  props: {
    code: {
      type: String,
      required: false,
      default: '',
    },
    output: {
      type: String,
      required: false,
      default: '',
    }
  },

  setup(props) {
    const form = useForm({});
    const code = ref('');

    const submit = () => {
      if (code.value === '') {
        return;
      }

      form
        .transform((data) => ({
          ...data,
          codeArea: code.value,
        }))
        .post('/practice', {
          preserveScroll: true,
        });
    };

    function onCodeChanged(value) {
      code.value = value;
    }

    return {
      form,
      code,
      submit,
      onCodeChanged,
    };
  },
}

</script>

<template>
  <Head title="Практическое задание"></Head>

  <div id="wrapper">
    <section id="slide-code">
      <div class="main-banner-area parallax">
        <div class="container">
          <div class="main-banner-content block">
            <h1 data-aos="fade-left">
              <span>Проверка кода</span>
            </h1>
          </div>
        </div>
      </div>
    </section>

    <section id="check-code">
      <div class="container">
        <div class="block_top">
          <div class="zadanie">
            <div class="zad_title">
              Описание задачи
            </div>
            <div class="zad_telo">
              Когда мы приходим на встречу, то первым делом здороваемся. Давайте тоже поприветствуемся.
            </div>
          </div>

          <div class="format">
            <div class="zad_title">
              Формат вывода
            </div>
            <div class="zad_telo">
              Одна строка: «Привет, Яндекс!»
            </div>
          </div>

          <span class="zad_status">Неверное решение</span>
        </div>

        <div class="block_bottom">
          <CodeArea :value="code" @update-code="onCodeChanged" />

          <textarea style="max-width: 50%; height: 300px; border-color: #1a1d20" disabled>{{ output }}</textarea>

          <div class="flex justify-start mt-4">
            <PrimaryButton v-on:click="submit" :class="{ 'opacity-25': form.processing }" :disabled="form.processing">
              Выполнить
            </PrimaryButton>
          </div>
        </div>

      </div>
    </section>
  </div>

  <CourseContent />
</template>
